// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package calculator_pb

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CalculatorServiceClient is the client API for CalculatorService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CalculatorServiceClient interface {
	PrimeNumDecompose(ctx context.Context, in *PrimeNumDecomposeRequest, opts ...grpc.CallOption) (*PrimeNumDecomposeResponse, error)
	ComputeAvg(ctx context.Context, in *ComputeAvgRequest, opts ...grpc.CallOption) (*ComputeAvgResponse, error)
}

type calculatorServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewCalculatorServiceClient(cc grpc.ClientConnInterface) CalculatorServiceClient {
	return &calculatorServiceClient{cc}
}

func (c *calculatorServiceClient) PrimeNumDecompose(ctx context.Context, in *PrimeNumDecomposeRequest, opts ...grpc.CallOption) (*PrimeNumDecomposeResponse, error) {
	out := new(PrimeNumDecomposeResponse)
	err := c.cc.Invoke(ctx, "/calculator.CalculatorService/PrimeNumberDecomposition", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *calculatorServiceClient) ComputeAvg(ctx context.Context, in *ComputeAvgRequest, opts ...grpc.CallOption) (*ComputeAvgResponse, error) {
	out := new(ComputeAvgResponse)
	err := c.cc.Invoke(ctx, "/calculator.CalculatorService/ComputeAverage", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CalculatorServiceServer is the server API for CalculatorService service.
// All implementations must embed UnimplementedCalculatorServiceServer
// for forward compatibility
type CalculatorServiceServer interface {
	PrimeNumDecompose(context.Context, *PrimeNumDecomposeRequest) (*PrimeNumDecomposeResponse, error)
	ComputeAvg(context.Context, *ComputeAvgRequest) (*ComputeAvgResponse, error)
	mustEmbedUnimplementedCalculatorServiceServer()
}

// UnimplementedCalculatorServiceServer must be embedded to have forward compatible implementations.
type UnimplementedCalculatorServiceServer struct {
}

func (UnimplementedCalculatorServiceServer) PrimeNumDecompose(context.Context, *PrimeNumDecomposeRequest) (*PrimeNumDecomposeResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method PrimeNumberDecomposition not implemented")
}
func (UnimplementedCalculatorServiceServer) ComputeAvg(context.Context, *ComputeAvgRequest) (*ComputeAvgResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ComputeAverage not implemented")
}
func (UnimplementedCalculatorServiceServer) mustEmbedUnimplementedCalculatorServiceServer() {}

// UnsafeCalculatorServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CalculatorServiceServer will
// result in compilation errors.
type UnsafeCalculatorServiceServer interface {
	mustEmbedUnimplementedCalculatorServiceServer()
}

func RegisterCalculatorServiceServer(s grpc.ServiceRegistrar, srv CalculatorServiceServer) {
	s.RegisterService(&CalculatorService_ServiceDesc, srv)
}

func _CalculatorService_PrimeNumDecompose_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PrimeNumDecomposeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CalculatorServiceServer).PrimeNumDecompose(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/calculator.CalculatorService/PrimeNumberDecomposition",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CalculatorServiceServer).PrimeNumDecompose(ctx, req.(*PrimeNumDecomposeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _CalculatorService_ComputeAvg_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ComputeAvgRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CalculatorServiceServer).ComputeAvg(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/calculator.CalculatorService/ComputeAverage",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CalculatorServiceServer).ComputeAvg(ctx, req.(*ComputeAvgRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// CalculatorService_ServiceDesc is the grpc.ServiceDesc for CalculatorService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var CalculatorService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "calculator.CalculatorService",
	HandlerType: (*CalculatorServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "PrimeNumberDecomposition",
			Handler:    _CalculatorService_PrimeNumDecompose_Handler,
		},
		{
			MethodName: "ComputeAverage",
			Handler:    _CalculatorService_ComputeAvg_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "CalculatorEndterm/calculator/calculator_pb/calculator.proto",
}
